/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.log.Logger
 *  fire.pb.main.ConfigManager
 *  fire.pb.move.SAddPickupScreen
 *  fire.pb.move.SRemovePickupScreen
 *  fire.pb.scene.Scene
 *  fire.pb.scene.SceneManager
 *  fire.pb.scene.movable.God
 *  fire.pb.scene.movable.HongBaoitem
 *  fire.pb.scene.movable.Pickup
 *  fire.pb.scene.sPos.GridPos
 *  fire.pb.scene.sPos.Position
 *  mkio.Protocol
 */
package fire.pb.scene.manager;

import fire.log.Logger;
import fire.pb.main.ConfigManager;
import fire.pb.move.SAddPickupScreen;
import fire.pb.move.SRemovePickupScreen;
import fire.pb.scene.Scene;
import fire.pb.scene.SceneManager;
import fire.pb.scene.movable.God;
import fire.pb.scene.movable.HongBaoitem;
import fire.pb.scene.movable.Pickup;
import fire.pb.scene.sPos.GridPos;
import fire.pb.scene.sPos.Position;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.atomic.AtomicLong;
import mkio.Protocol;

public class PickUpManager {
    private static PickUpManager instance;
    public static final int PICK_UP_TYPE_TNSH = 1;
    public static final int PICK_UP_TYPE_JFJP = 2;
    public static final int PICK_UP_TYPE_HONGBAO = 3;
    public static final int PICK_UP_TYPE_BOATPARTYFOOD = 4;
    public static final int PICK_UP_TYPE_COMMONITEM = 5;
    public static long lastPickupTime;
    Logger logger = Logger.getLogger((String)"MAPMAIN");
    public Map<Long, GridPos> hongbaoList = new ConcurrentHashMap<Long, GridPos>();
    private final Map<Long, Pickup> pickups = new ConcurrentHashMap<Long, Pickup>();
    private AtomicLong nextkey = new AtomicLong(0L);

    private PickUpManager(ConfigManager cm) {
    }

    public static PickUpManager getInstance() {
        if (null == instance) {
            instance = new PickUpManager(ConfigManager.getInstance());
        }
        return instance;
    }

    public Pickup getPickup(Long uniqueID) {
        return this.pickups.get(uniqueID);
    }

    public Set<Long> getPickupKeyset() {
        return this.pickups.keySet();
    }

    public List<Pickup> getPickupsInScreens(Scene scene, Set<Integer> indexs) {
        LinkedList<Pickup> list = new LinkedList<Pickup>();
        for (Pickup p : this.pickups.values()) {
            if (!p.getScene().equals(scene) || !indexs.contains(p.getMyScreenIndex())) continue;
            list.add(p);
        }
        return list;
    }

    public List<Pickup> getPickupsInScene(Scene scene) {
        LinkedList<Pickup> list = new LinkedList<Pickup>();
        for (Pickup p : this.pickups.values()) {
            if (!p.getScene().equals(scene)) continue;
            list.add(p);
        }
        return list;
    }

    private void add(Pickup p) {
        if (this.pickups.containsKey(p.getUniqueID())) {
            this.logger.info((Object)("pickups contains key.key:" + p.getUniqueID() + "pickups.size:" + this.pickups.size()));
            return;
        }
        this.pickups.put(p.getUniqueID(), p);
        SAddPickupScreen snd = new SAddPickupScreen();
        snd.pickuplist.add(p.getPickupBasic());
        this.logger.info((Object)("send pickup to client.size:" + snd.pickuplist.size()));
        p.sendAround((Protocol)snd);
    }

    public void remove(long id) {
        Pickup p = this.pickups.get(id);
        if (null == p) {
            return;
        }
        Scene ps = p.getScene();
        if (null == ps) {
            return;
        }
        SRemovePickupScreen snd = new SRemovePickupScreen();
        snd.pickupids.add(id);
        p.sendAround((Protocol)snd);
        this.pickups.remove(id);
    }

    public Pickup plant(int baseID, long mapID, GridPos pos, int pickupType) {
        long id = this.nextkey.incrementAndGet();
        if (id > Long.MAX_VALUE) {
            return null;
        }
        Scene scene = SceneManager.getInstance().getSceneByID(mapID);
        if (null == scene) {
            return null;
        }
        Pickup pickup = God.createPickup((long)id, (int)baseID, null, (Scene)scene, (Position)pos.toPosition(), (int)pickupType);
        this.add(pickup);
        return pickup;
    }

    public HongBaoitem plantHongBao(int baseID, long mapID, GridPos pos, long moneyNum) {
        long id = this.nextkey.incrementAndGet();
        if (id > Long.MAX_VALUE) {
            return null;
        }
        Scene scene = SceneManager.getInstance().getSceneByID(mapID);
        if (null == scene) {
            return null;
        }
        HongBaoitem HongBaoitem2 = God.createHongBaoitem((long)id, (int)baseID, (Scene)scene, (Position)pos.toPosition(), (long)moneyNum);
        this.add((Pickup)HongBaoitem2);
        return HongBaoitem2;
    }

    /*
     * WARNING - Removed try catching itself - possible behaviour change.
     */
    public int getPickupNum(long sceneid, int pickupType) {
        int val = 0;
        Map<Long, Pickup> map = this.pickups;
        synchronized (map) {
            for (Pickup p : this.pickups.values()) {
                if ((long)p.getScene().getMapID() != sceneid || p.getPickupType() != pickupType) continue;
                ++val;
            }
        }
        return val;
    }

    /*
     * WARNING - Removed try catching itself - possible behaviour change.
     */
    public int getPickupBaseNum(long sceneid, int baseId) {
        int val = 0;
        Map<Long, Pickup> map = this.pickups;
        synchronized (map) {
            for (Pickup p : this.pickups.values()) {
                if ((long)p.getScene().getMapID() != sceneid || p.getBaseID() != baseId) continue;
                ++val;
            }
        }
        return val;
    }

    static {
        lastPickupTime = 0L;
    }
}

